#!/bin/sh

CURRENT_PATH=$PWD
LINUX_VERSION=$1

export USE_GTK3=Yes
export USE_PKGCONFIG=Yes
export USE_LUA_VERSION=54
export USE_LUA54=Yes
export LUA_LIB=$CURRENT_PATH/lua-5.4.4/src
export LUA_INC=$CURRENT_PATH/lua-5.4.4/src
export IM_LIB=$CURRENT_PATH/im/lib/$LINUX_VERSION
export IM_INC=$CURRENT_PATH/im/include
export FTGL_LIB=$CURRENT_PATH/ftgl/lib/$LINUX_VERSION
export FTGL_INC=$CURRENT_PATH/ftgl/include
export PDFLIB_LIB=$CURRENT_PATH/pdflib7/lib/$LINUX_VERSION
export PDFLIB_INC=$CURRENT_PATH/pdflib7/include
export CD_LIB=$CURRENT_PATH/cd/lib/$LINUX_VERSION
export CD_INC=$CURRENT_PATH/cd/include

cd lua-5.4.4
make linux
ln -s liblua.a src/liblua54.a

mkdir -p $CURRENT_PATH/lua54/bin/$LINUX_VERSION
ln -sf $LUA_LIB/lua $CURRENT_PATH/lua54/bin/$LINUX_VERSION/lua54

cd ../pdflib7
make

cd ../ftgl
make

cd ../fftw
./configure --enable-shared --prefix=/usr
make -j16
make install
make clean
./configure --enable-shared --enable-float--prefix=/usr
make -j16
make install

cd ../im
make

cd ../cd
make

cd ../iup
# patch -p1 < without-lua-prefix-with-linux6.patch
make
